( function( $ ) {

	/**
	 * Function for Before After Slider animation.
	 *
	 */
	var UAELBASlider = function( $element ) {

		$element.css( 'width', '' );
		$element.css( 'height', '' );

		max = -1;

		$element.find( "img" ).each(function() {
			if( max < $(this).width() ) {
				max = $(this).width();
			}
		});

		$element.css( 'width', max + 'px' );
	}

	/**
	 * Function for GF Styler select field.
	 *
	 */
	var WidgetUAELGFStylerHandler = function( $scope, $ ) {

		if ( 'undefined' == typeof $scope )
			return;

		var	gfSelectFields = $scope.find('select:not([multiple])');

		gfSelectFields.wrap( "<span class='uael-gf-select-custom'></span>" );
	}

	/**
	 * Function for CF7 Styler select field.
	 *
	 */
	var WidgetUAELCF7StylerHandler = function( $scope, $ ) {

		if ( 'undefined' == typeof $scope )
			return;

		var	cf7SelectFields = $scope.find('select:not([multiple])'),
			cf7Loader = $scope.find('span.ajax-loader');


		cf7SelectFields.wrap( "<span class='uael-cf7-select-custom'></span>" );

		cf7Loader.wrap( "<div class='uael-cf7-loader-active'></div>" );

		var wpcf7event = document.querySelector( '.wpcf7' );

		wpcf7event.addEventListener( 'wpcf7submit', function( event ) {
			var cf7ErrorFields = $scope.find('.wpcf7-not-valid-tip');
		    cf7ErrorFields.wrap( "<span class='uael-cf7-alert'></span>" );
		}, false );

	}

	/**
	 * Function for Fancy Text animation.
	 *
	 */
	var UAELFancyText = function() {

		var id 					= $( this ).data( 'id' );
		var $this 				= $( this ).find( '.uael-fancy-text-node' );
		var animation			= $this.data( 'animation' );
		var fancystring 		= $this.data( 'strings' );
		var nodeclass           = '.elementor-element-' + id;

		var typespeed 			= $this.data( 'type-speed' );
		var backspeed 			= $this.data( 'back-speed' );
		var startdelay 			= $this.data( 'start-delay' );
		var backdelay 			= $this.data( 'back-delay' );
		var loop 				= $this.data( 'loop' );
		var showcursor 			= $this.data( 'show_cursor' );
		var cursorchar 			= $this.data( 'cursor-char' );

		var speed 				= $this.data('speed');
		var pause				= $this.data('pause');
		var mousepause			= $this.data('mousepause');

		if ( 'type' == animation ) {
			$( nodeclass + ' .uael-typed-main' ).typed({
				strings: fancystring,
				typeSpeed: typespeed,
				startDelay: startdelay,
				backSpeed: backspeed,
				backDelay: backdelay,
				loop: loop,
				showCursor: showcursor,
				cursorChar: cursorchar,
	        });
		} else if ( 'slide' == animation ) {

			$( nodeclass + ' .uael-slide-main' ).vTicker('init', {
					strings: fancystring,
					speed: speed,
					pause: pause,
					mousePause: mousepause,
			});
		}
	}

	/**
	 * Before After Slider handler Function.
	 *
	 */
	var WidgetUAELBASliderHandler = function( $scope, $ ) {

		if ( 'undefined' == typeof $scope )
			return;

		var selector = $scope.find( '.uael-ba-container' );
		var initial_offset = selector.data( 'offset' );
		var move_on_hover = selector.data( 'move-on-hover' );
		var orientation = selector.data( 'orientation' );

		$scope.css( 'width', '' );
		$scope.css( 'height', '' );

		if( 'yes' == move_on_hover ) {
			move_on_hover = true;
		} else {
			move_on_hover = false;
		}

		$scope.imagesLoaded( function() {

			UAELBASlider( $scope );

			$scope.find( '.uael-ba-container' ).twentytwenty(
	            {
	                default_offset_pct: initial_offset,
	                move_on_hover: move_on_hover,
	                orientation: orientation
	            }
	        );

	        $( window ).resize( function( e ) {
	        	UAELBASlider( $scope );
	        } );
		} );
	};

	/**
	 * Fancy text handler Function.
	 *
	 */
	var WidgetUAELFancyTextHandler = function( $scope, $ ) {
		if ( 'undefined' == typeof $scope ) {
			return;
		}
		var node_id = $scope.data( 'id' );
		var viewport_position	= 90;
		var selector = $( '.elementor-element-' + node_id );

		if( typeof elementorFrontend.waypoint !== 'undefined' ) {
			elementorFrontend.waypoint(
				selector,
				UAELFancyText,
				{
					offset: viewport_position + '%'
				}
			);
		}
	};

	/**
	 * Radio Button Switcher JS Function.
	 *
	 */
	var WidgetUAELContentToggleHandler = function( $scope, $ ) {
		if ( 'undefined' == typeof $scope ) {
			return;
		}
		var $this           = $scope.find( '.uael-rbs-wrapper' );
		var node_id 		= $scope.data( 'id' );
		var rbs_section_1   = $scope.find( ".uael-rbs-section-1" );
		var rbs_section_2   = $scope.find( ".uael-rbs-section-2" );
		var main_btn        = $scope.find( ".uael-main-btn" );
		var switch_type     = $( main_btn ).attr( 'data-switch-type' );
		var current_class;

		switch ( switch_type ) {
			case 'round_1':
				current_class = '.uael-switch-round-1';
				break;
			case 'round_2':
				current_class = '.uael-switch-round-2';
				break;
			case 'rectangle':
				current_class = '.uael-switch-rectangle';
				break;
			case 'label_box':
				current_class = '.uael-switch-label-box';
				break;
			default:
				current_class = 'No Class Selected';
				break;
		}

		var rbs_switch      = $scope.find( current_class );

		if( $( rbs_switch ).is( ':checked' ) ) {
			$( rbs_section_1 ).hide();
		} else {
			$( rbs_section_2 ).hide();
		}

		$( rbs_switch ).click(function(){
	        $( rbs_section_1 ).toggle();
	        $( rbs_section_2 ).toggle();
	    });
	};

	/**
	 * Table handler Function.
	 *
	 */
	var WidgetUAELTableHandler = function( $scope, $ ) {
		if ( 'undefined' == typeof $scope ) {
			return;
		}
		// Define variables.
		var $this                = $scope.find( '.uael-table-wrapper' );
		var node_id              = $scope.data( 'id' );
		var uael_table           = $scope.find( '.uael-table' );
		var uael_table_name      = $scope.find( '.sort-this' );
		var uael_search_table    = $scope.find( '.uael-search-table' );
		var uael_search_box      = $scope.find( '#uael-search-box' );
		var uael_show_entries    = $scope.find( '#uael-show-entries' );
		var uael_table_id        = $scope.find( '#uael-table-id' );
		var on_responsive        = $scope.find( '.on-responsive' );

		// Show entries select
		var show_entry = $( '.elementor-element-' + node_id + ' #' + uael_table_id[0].id ).attr( 'show-entry' );

		if ( 'yes' == show_entry ) {
			$( '.elementor-element-' + node_id + ' #' + uael_show_entries[0].id ).on('change', function() {
				var total_entries = $( '.elementor-element-' + node_id + ' #' + uael_show_entries[0].id + ' option:last' ).val();
				for (var i=2; i <= total_entries; i++) {
					if (i <= parseInt(this.value)) {
						$( '.elementor-element-' + node_id + ' [data-entry="' + i + '"]').show();
					} else {
						$( '.elementor-element-' + node_id + ' [data-entry="' + i + '"]').hide();
					}
				}
			})
		}

		function sortTable(n) {
			var table, rows, switching, i, x, y, shouldSwitch, dir, switchcount = 0;
			table = uael_table;
			switching = true;
			//Set the sorting direction to ascending.
			dir = "asc";
			/*Make a loop that will continue until
			no switching has been done.*/
			while ( switching ) {
				//start by saying: no switching is done.
				switching = false;
				if( uael_table[0] ) {
					var uael_tbody = uael_table[0].getElementsByTagName( 'TBODY' );
					var rows = uael_tbody[0].getElementsByTagName( 'TR' );
				}
				/*Loop through all table rows (except the
				first, which contains table headers).*/
				for ( i = 0; i < ( rows.length - 1); i++ ) {
					//start by saying there should be no switching:
					shouldSwitch = false;
					/*Get the two elements you want to compare,
					one from current row and one from the next.*/
					x = rows[i].getElementsByClassName("uael-table-col")[n];
					y = rows[i + 1].getElementsByClassName("uael-table-col")[n];
					/*check if the two rows should switch place,
					based on the direction, asc or desc.*/
					if ( dir == "asc" ) {
						$( '.elementor-element-' + node_id + ' #' + uael_table_id[0].id + ' .uael-sort-icon' ).removeClass('fa-sort-up');
						$( '.elementor-element-' + node_id + ' #' + uael_table_id[0].id + ' .uael-sort-icon' ).removeClass('fa-sort-down');
						$( '.elementor-element-' + node_id + ' #' + uael_table_id[0].id + ' .uael-sort-icon' ).addClass('fa-sort');
						$("[data-sort=" + n + "] .sort-style i").removeClass( "fa-sort-up" );
						$("[data-sort=" + n + "] .sort-style i").addClass( "fa fa-sort-up" );
						if ( x.innerHTML.toLowerCase() > y.innerHTML.toLowerCase() ) {
							//if so, mark as a switch and break the loop.
							shouldSwitch= true;
							break;
						}
					} else if ( dir == "desc" ) {
						$( '.elementor-element-' + node_id + ' #' + uael_table_id[0].id + ' .uael-sort-icon' ).removeClass('fa-sort-up');
						$( '.elementor-element-' + node_id + ' #' + uael_table_id[0].id + ' .uael-sort-icon' ).removeClass('fa-sort-down');
						$( '.elementor-element-' + node_id + ' #' + uael_table_id[0].id + ' .uael-sort-icon' ).addClass('fa-sort');
						$("[data-sort=" + n + "] .sort-style i").removeClass( "fa-sort-down" );
						$("[data-sort=" + n + "] .sort-style i").addClass( "fa fa-sort-down" );
						if ( x.innerHTML.toLowerCase() < y.innerHTML.toLowerCase() ) {
							//if so, mark as a switch and break the loop.
							shouldSwitch= true;
							break;
						}
					}
				}
				if ( shouldSwitch ) {
					/*If a switch has been marked, make the switch
					and mark that a switch has been done.*/
					rows[i].parentNode.insertBefore( rows[i + 1], rows[i] );
					switching = true;
					//Each time a switch is done, increase this count by 1.
					switchcount ++;
				} else {
					/*If no switching has been done AND the direction is "asc",
					set the direction to "desc" and run the while loop again.*/
					if ( switchcount == 0 && dir == "asc" ) {
						dir = "desc";
						switching = true;
					}
				}
			}
		}
		// Call function on column click.
		var sort_table = $( '.elementor-element-' + node_id + ' #' + uael_table_id[0].id ).attr( 'sort-table' );
		if ( 'yes' == sort_table ) {
			$( '.elementor-element-' + node_id + ' #' + uael_table_id[0].id + ' th' ).css({'cursor': 'pointer'});
			$( uael_table_name ).click(function() {
				var col_number = $( this ).attr( 'data-sort' );
				if (typeof col_number !== typeof undefined && col_number !== false) {
					sortTable(col_number);
				}
			});
		}

		// Search table algorithm.
		function searchTable() {
			var input, filter, table, tr, td, i;
			input = $( '.elementor-element-' + node_id + ' #' + uael_search_box[0].id ).get( 0 );
			filter = input.value.toUpperCase();
			// Convert input elements to uppercase.
			table = $( '.elementor-element-' + node_id + ' #' + uael_table_id[0].id ).get( 0 );
			tr = table.getElementsByTagName("tr");
			for (i = 0; i < tr.length; i++) {
				// Get all column values
				td_all = tr[i].getElementsByTagName("td");
				if (td_all != 0) {
					for (var k = 0; k < td_all.length; k++ ) {
						td = tr[i].getElementsByTagName("td")[k];
						if (td) {
							if (td.innerHTML.toUpperCase().indexOf(filter) > -1) {
								tr[i].style.display = "";
								break;
							} else {
								tr[i].style.display = "none";
							}
						}
					}
				}
			}
		}
		// Search on keyup algorithm.
		$( uael_search_table ).keyup(function() {
			searchTable();
		});

		function coloumn_rules() {
			if($(window).width() > 767) {
				$(uael_table).addClass('column-rules');
				$(uael_table).removeClass('no-column-rules');
			}else{
				$(uael_table).removeClass('column-rules');
				$(uael_table).addClass('no-column-rules');
			}
		}

		// Listen for events.
		window.addEventListener("load", coloumn_rules);
		window.addEventListener("resize", coloumn_rules);
	};

	$( window ).on( 'elementor/frontend/init', function () {

		elementorFrontend.hooks.addAction( 'frontend/element_ready/uael-fancy-heading.default', WidgetUAELFancyTextHandler );

		elementorFrontend.hooks.addAction( 'frontend/element_ready/uael-ba-slider.default', WidgetUAELBASliderHandler );

		elementorFrontend.hooks.addAction( 'frontend/element_ready/uael-content-toggle.default', WidgetUAELContentToggleHandler );

		elementorFrontend.hooks.addAction( 'frontend/element_ready/uael-gf-styler.default', WidgetUAELGFStylerHandler );

		elementorFrontend.hooks.addAction( 'frontend/element_ready/uael-cf7-styler.default', WidgetUAELCF7StylerHandler );

		elementorFrontend.hooks.addAction( 'frontend/element_ready/uael-table.default', WidgetUAELTableHandler );

		if( elementorFrontend.isEditMode() ) {

			elementor.channels.data.on( 'element:after:duplicate element:after:remove', function( e, arg ) {
				$( '.elementor-widget-uael-ba-slider' ).each( function() {
					WidgetUAELBASliderHandler( $( this ), $ );
				} );
			} );
		}
	});
} )( jQuery );
